use strict;
use warnings;
use Config;
use File::Copy q(copy);
use File::Find q(finddepth);
use File::Path qw(make_path);
die "Not a strawberry perl\n" unless $Config{myuname} =~ /strawberry\-?perl/i;
my $bits = ( $Config{ptrsize} == 8 ) ? '64' : '32';
my $target = $Config{incpath};
die "Some bad incpath, excpecting ../c/include but got '$target'" unless $target =~ m[(.*[/\\]c)[/\\]include$];
$target = $1;
$target =~ s[\\][/]g;

my $deinstall = 1 if ($ARGV[0] // '') eq '-d';

my @install = qw(bin include lib);

$|++;

for my $src_dir ( @install ) {
	$src_dir = "$bits/$src_dir";
	finddepth( sub {
		return if -d;
		my $target_dir = $File::Find::dir;
		$target_dir =~ s/^\Q$bits\E[\\\/]//;
		$deinstall ? 
			deinstall("$target/$target_dir/$_") :
			install( "$File::Find::dir", $_, "$target/$target_dir/$_");
	}, $src_dir);
}

sub install
{
	my ($src_dir, $src, $dst) = @_;
	print "$dst";
	if ( -f $dst ) {
		print " skipped\n";
		return;
	}
	my $path = $dst;
	$path =~ s{\/[^\/]+$}{}g;
	unless (-d $path) {
		make_path($path) or die "Cannot create $path:$!\n";
	}
	copy($src, $dst) or die "Cannot copy:$!\n";
	print "\n";
}

sub deinstall
{
	my ($dst) = @_;
	return unless -f $dst;
	print "rm $dst\n";
	unlink($dst) or warn "Cannot delete $dst:$!\n";
}
